(* file: positionalAdd.ml
 * author: Bob Muller
 *
 * CS1101 Computer Science I
 *
 * Add a list of digits in a positional numeral system.
 *
 * addDigits : int -> int -> int * int
 *)
let addDigits n base =
  let carryOut = n / base in
  let sum = n mod base
  in
  (carryOut, sum)

(* positionalAdd : int list -> int list -> int -> int list
 *)
let positionalAdd ms ns base =
  let rec repeat ms ns carryIn acc =
    match (ms, ns) with
    | ([], []) -> acc
    | (m :: ms, n :: ns) ->
       let (carryOut, sum) = addDigits (m + n + carryIn) base
       in
       repeat ms ns carryOut (sum :: acc)
  in
  repeat (List.rev ms) (List.rev ns) 0 []
